{$N+}

Library OVTableRowFunctions;

Uses WinTypes, WinProcs, Strings;

Type

{Prototype callback functions to be used}

ExecuteStringType=function(ExecStr, Other_String: PChar; W1, W2: word): PChar;
IsColumnType=function(IsCol:PChar): Integer;
GetCurrentRowType=function(GCRow: Integer): Integer;
GetLastRowType=function(GLRow: Integer):Integer;
SetCurrentRowType=function(SCRow,CRow: Integer): Integer;
SetLinkRowType=function(SLRow,CRow: Integer): Integer;
NextColumnType=function(NexCol:Integer;Other_String: PChar):PChar;

Function TableFunctions(CallBackString: ExecuteStringType):Integer; Export;
 Begin
  CallBackString('@MESSAGE("Registering six (6) table callback functions")','',0,0);
  CallBackString('@REGISTER("@OVIsColumn","IrC","ColumnName","tblfunc.dll","IsColumn",0)','',0,0);
  CallBackString('@REGISTER("@OVGetCurrentRow","IoI","TableHandle","tblfunc.dll","GetCurrentRow",0)','',0,0);
  CallBackString('@REGISTER("@OVGetLastRow","IqI","TableHandle","tblfunc.dll","GetLastRow",0)','',0,0);
  CallBackString('@REGISTER("@OVNextColumn","CpIC","Table Handle,Column Name","tblfunc.dll","NextColumn",0)','',0,0);
  CallBackString('@REGISTER("@OVSetCurrentRow","IsII","TableHandle,Row","tblfunc.dll","SetCurrentRow",0)','',0,0);
  CallBackString('@REGISTER("@OVSetLinkRow","IsII","TableHandle,Row","tblfunc.dll","SetLinkRow",0)','',0,0);

  TableFunctions:=1;
 End;
Function IsColumn(IC:IsColumnType;ColumnName:PChar):Integer;Export;
 Begin
  IsColumn:=IC(ColumnName);
 End;
Function GetCurrentRow(GCR:GetCurrentRowType;TableHandle:Integer):Integer;Export;
 Begin
  GetCurrentRow:=GCR(TableHandle);
 End;
Function GetLastRow(GLR:GetLastRowType;TableHandle:Integer):Integer;Export;
 Begin
  GetLastRow:=GLR(TableHandle);
 End;
Function SetCurrentRow(SCR:SetCurrentRowType;TableHandle,CurrentRow: Integer):Integer;Export;
 Begin
  SetCurrentRow:=SCR(TableHandle,CurrentRow);
 End;
Function SetLinkRow(SLR:SetLinkRowType;TableHandle,CurrentRow: Integer):Integer;Export;
 Begin
  SetLinkRow:=SLR(TableHandle,CurrentRow);
End;
Function NextColumn(NC:NextColumnType;TableHandle:Integer;ColumnName:PChar):PChar;Export;
 Begin
  NextColumn:=NC(TableHandle,ColumnName);
 End;

Exports

  TableFunctions	index 1,
  IsColumn		index 2,
  GetCurrentRow		index 3,
  GetLastRow		index 4,
  SetCurrentRow		index 5,
  SetLinkRow		index 6,
  NextColumn		index 7;

Begin
End.
